# Kitchen::K8s

[![Build Status](https://img.shields.io/travis/mickfeech/kitchen-k8s.svg)](https://travis-ci.org/mickfeech/kitchen-k8s)
[![Gem Version](https://badge.fury.io/rb/kitchen-k8s.svg)](https://badge.fury.io/rb/kitchen-k8s)
[![Maintainability](https://api.codeclimate.com/v1/badges/d8b7b21a196fecda1b18/maintainability)](https://codeclimate.com/github/mickfeech/kitchen-k8s/maintainability)

A [Test Kitchen](https://github.com/test-kitchen/test-kitchen) driver for testing on top of a Kubernetes cluster.

## Installation

Prerequisites: 

An installed and configured `kubectl` binary. 

Install the driver:

```ruby
chef gem install kitchen-k8s
```

Configure your `kitchen.yml` to use the driver:

```yaml
---
  driver:
    name: k8s
    api_server: http://your-k8s-api-server/api
    namespace: default
    token: <your bearer token>
    image: centos:latest
    service_account: default
```

## Options

You can customize things by setting additonal options in the `driver` section:

```yaml
---
  driver:
    name: k8s
    api_server: http://your-k8s-api-server/api
    namespace: default
    token: <your bearer token>
    image: centos:latest
    service_account: default
```

* `api_server` - **Currently unused** The Kubernetes api server that will be used to make connections, used for direct API calls when creating pods (_default: http://localhost:8080/api_)
* `api_version` - **Currently unused** The version of the Kubernetes API, used in direct API calls (_default: v1_)
* `binary` - The path to kubectl (_default: kubectl_)
* `image` - The default docker image to pull in for testing (_default: centos:latest_)
* `kubeconfig` - The location of your kubeconfig file (_default: ~/.kube/config_)
* `namespace` - The Kuberentes namespace where the pod will spin up in (_default: default_)
* `service_account` - The Kubernetes service account that will be running the pod (_default: default_)
* `token` - **Currently unused** The bearer token of the user used to authenticate API calls
* `platform` - The platform being tested against (_default: auto detect_)
* `pod_name` - The name of the generated pod (_default: auto generate_)


## Contributing

Bug reports and pull requests are welcome on GitHub at [https://github.com/mickfeech/kitchen-k8s](https://github.com/mickfeech/kitchen-k8s).


## License

Copyright 2018, Chris McFee

Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License. You may obtain a copy of the License at: [http://www.apache.org/licenses/LICENSE-2.0](http://www.apache.org/licenses/LICENSE-2.0).

Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.
