# coding: utf-8

lib = File.expand_path('../lib', __FILE__)
$LOAD_PATH.unshift(lib) unless $LOAD_PATH.include?(lib)
require 'kitchen/driver/k8s_version'

Gem::Specification.new do |spec|
  spec.name          = 'kitchen-k8s'
  spec.version       = Kitchen::Driver::K8S_VERSION
  spec.authors       = ['Chris McFee']
  spec.email         = ['cmcfee@kent.edu']

  spec.description   = 'A Kubernetes Driver for Test Kitchen'
  spec.summary       = spec.description
  spec.homepage      = 'https://github.com/mickfeech'
  spec.license       = 'Apache 2.0'

  spec.files         = `git ls-files`.split($RS)
  spec.executables   = []
  spec.test_files    = spec.files.grep(%r{^(test|spec|features)/})
  spec.require_paths = ['lib']

  spec.add_dependency 'kubeclient', '~> 3.0.0'
  spec.add_dependency 'test-kitchen', '>= 1.20.0'

  spec.add_development_dependency 'bundler', '~> 1.14'
  spec.add_development_dependency 'rake', '~> 10.0'

  # Style checks
  spec.add_development_dependency 'countloc'
  spec.add_development_dependency 'rubocop', '~> 0.49.0'
  # Unit tests
  spec.add_development_dependency 'rspec', '~> 3.2'
  spec.add_development_dependency 'rspec-its', '~> 1.2'
  spec.add_development_dependency 'fuubar', '~> 2.0'
  spec.add_development_dependency 'simplecov', '~> 0.9'
  spec.add_development_dependency 'codecov', '~> 0.0', '>= 0.0.2'
  # Integration testing gems.
  spec.add_development_dependency 'kitchen-inspec', '~> 0.14'
end
